# 3)

echo 'DATAFILE
data.txt
TRAITS
 3
FIELDS_PASSED TO OUTPUT

WEIGHT(S)

RESIDUAL_VARIANCE
40
EFFECT
2 cross alpha  #sex
EFFECT
1  cross alpha
RANDOM
animal
FILE
ped.txt
FILE_POS
1 2 3 0 0
PED_DEPTH
3
(CO)VARIANCES
20' > renum.par

echo '4 male    4.5
5 female  2.9
6 female  3.9
7 male    3.5
8 male    5.0' > data.txt

echo '4 1 0
5 3 2
6 1 2
7 4 5
8 3 6' > ped.txt


#Run renumf90
renumf90 renum.par | tee renum.log

#4)
#Run blupf90+
echo 'OPTION sol se' >> renf90.par
blupf90+ renf90.par | tee blup.log

#Print solutions and reliabilities using renumbered ID
awk '{print $1,$10}' renadd02.ped | sort +0 -1 > p.temp
awk '$2==2{print $3,$4,(1-($5*$5/20)),(1-($5*$5/20))^0.5,$5}' solutions | sort +0 -1 > s.temp
join -1 +1 -2 +1 p.temp s.temp | sort +1 -2 > sol.new

#Obtain reliabilities from blupf90+
echo 'OPTION store_accuracy 2' >> renf90.par
blupf90+ renf90.par | tee blup.log


# 7) Estimating VC with REML and AIREML methods using exmr99s1
#REML
cp exmr99s1 em_exmr99s1
echo 'OPTION method VCE
OPTION EM-REML -200' >> em_exmr99s1
time blupf90+ em_exmr99s1 | tee reml.log

#AIREML
cp exmr99s1 ai_exmr99s1
echo 'OPTION method VCE' >> ai_exmr99s1
time blupf90+ ai_exmr99s1 | tee aireml.log

#Two-trait model - REML
cp exmr99s2 em_exmr99s2
echo 'OPTION method VCE
OPTION EM-REML -500' >> em_exmr99s2
time blupf90+ em_exmr99s2 | tee reml2.log

#Two-trait model - AIREML
cp exmr99s2 ai_exmr99s2
echo 'OPTION method VCE
OPTION se_covar_function h2_t1 G_3_3_1_1/(G_2_2_1_1+G_3_3_1_1+R_1_1)
OPTION se_covar_function h2_t2 G_3_3_2_2/(G_2_2_2_2+G_3_3_2_2+R_2_2)
OPTION se_covar_function rg12 G_3_3_1_2/(G_3_3_1_1*G_3_3_2_2)**0.5' >> ai_exmr99s2
time blupf90+ ai_exmr99s2 | tee aireml2.log


#8) Run gibbsf90+
gibbsf90+ exmr99s1 --samples 1000 --burnin 0 --interval 1 | tee gibbs.log
#or
printf "%s\n" "exmr99s1" "1000 0" "1" | gibbsf90+ > gibbs2.log

printf "%s\n" "exmr99s1" "0" "1" "1" "1 2 3"| postgibbsf90
#or
postgibbsf90 exmr99s1
0
1
1
1 2 3
0

printf "%s\n" "exmr99s1" "200" "1" "1" "1 2 3"| postgibbsf90
#or
postgibbsf90 exmr99s1
200
1
1
1 2 3
0

#G matrix for effect =           2
#   891.64
# G matrix for effect =           3
#   2578.6
# R matrix
#   1816.7


#9) Run gibbsf90+ with fixed variance components for EBV
cp exmr99s1 gibbs.par
sed -i '17s/1806.4187/1816.7/' gibbs.par
sed -i '25s/1091.6244/891.64/' gibbs.par
sed -i '33s/2403.6412/2578.6/' gibbs.par
echo 'OPTION fixed_var mean 3' >> gibbs.par

gibbsf90+ gibbs.par --samples 1000 --burnin 200 --interval 1 | tee gibbs2_ebv.log


#10) Run RRM
renumf90 renrr.par | tee renum.log
blupf90+ renf90.par | tee blup.log
